package com.zilber.boot.activiti.dto;

import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import javax.validation.constraints.Max;
import javax.validation.constraints.Positive;
import javax.validation.constraints.PositiveOrZero;
import java.io.Serializable;

@Getter
@Setter
public class PageQueryDTO implements Serializable {

    @ApiModelProperty("每页记录数")
    @Positive(message = "分页数量必须为正整数")
    private Integer pageSize = 20;

    @ApiModelProperty("当前页数")
    @PositiveOrZero(message = "分页数不正确")
    private Integer pageNo = 0;
}
