package com.zilber.boot.activiti.service;


import com.zilber.boot.activiti.dto.TaskQueryDTO;
import com.zilber.boot.activiti.vo.HistoricTaskVO;
import org.activiti.engine.history.HistoricTaskInstance;
import org.activiti.engine.history.HistoricTaskInstanceQuery;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.StringUtils;

import javax.annotation.Resource;
import java.util.List;

import java.util.stream.Collectors;


@Service(value = "HistoryService_")
public class HistoryService {

    @Resource
    private org.activiti.engine.HistoryService historyService;

    public List<HistoricTaskVO> historicTaskPage(TaskQueryDTO dto) {
        HistoricTaskInstanceQuery taskInstanceQuery = historyService.createHistoricTaskInstanceQuery()
                .finished()
                .orderByHistoricTaskInstanceEndTime()
                .desc();
        if (!StringUtils.isEmpty(dto.getAssignee())) {
            taskInstanceQuery.taskAssignee(dto.getAssignee());
        }
        if (!StringUtils.isEmpty(dto.getProcDefKey())) {
            taskInstanceQuery.processDefinitionKey(dto.getProcDefKey());
        }
        if (!StringUtils.isEmpty(dto.getProcInstId())) {
            taskInstanceQuery.processInstanceId(dto.getProcInstId());
        }
        List<HistoricTaskInstance> tasks = taskInstanceQuery.listPage(dto.getPageNo() * dto.getPageSize(), dto.getPageSize());
        return HistoricTaskVO.merge(tasks);

    }

    public List<HistoricTaskVO> getListOfInstance(String instanceId) {
        List<HistoricTaskInstance> list = historyService.createHistoricTaskInstanceQuery()
                .orderByHistoricTaskInstanceStartTime()
                .asc()
                .processInstanceId(instanceId)
                .list();
        return list.stream()
                .map(HistoricTaskVO::merge)
                .collect(Collectors.toList());

    }
}
